function [tsdown2] = highpass(tsdown,Fs)
%INPUT: data: data series (one channel is one column)
%       fs: Sampling frequency
%       flowpass: lowpass frequency [Hz]
%
%OUTPUT: data_filtered: filtered data set
%
%[S1 S2 S3]=size(SS);
hlowpass=10;
[~, n_series]=size(tsdown);


for i=1:n_series
    if hlowpass ~=Inf
        hnormalized=2*hlowpass/Fs;
        [b,a] = butter(10,hnormalized,'high');   %order 10 butterworth filter
        data_filtered=filtfilt(b,a,tsdown(:,i));
    else
        data_filtered=tsdown(:,i);
    end
    tsdown2(:,i)=data_filtered;
end
end

%INPUT: data: data series (one channel is one column)
%       fs: Sampling frequency
%       flowpass: lowpass frequency [Hz]
%
%OUTPUT: data_filtered: filtered data set
%
%[S1 S2 S3]=size(SS);
% flowpass=20;
% Fs=200;
% t=linspace(0,10*180,length(ts(:,1)));
% 
%         if flowpass ~=Inf
%             fnormalized=2*flowpass/Fs;
%             [b,a] = butter(10,fnormalized,'low');   %order 10 butterworth filter
%             data_filtered=filtfilt(b,a,ts(:,1));
%         else
%             data_filtered=ts(:,1);
%         end
%         SS2(1,1,:)=data_filtered;
% 
% plot(t,ts(:,1),'b',t,data_filtered,'r')
% 
