close all

%% begrenser til 10 minutter
if length(Wind_polar_raw)>120001
   ts=ts(1:120000,:);
   Wind_polar_raw=Wind_polar_raw(1:120000,:);
end


%% Remove false values
downsamplingsverdi=20;


clear Wind_polar
t_raw=(0:size(Wind_polar_raw,1)-1)*1/200;
Wind_polar=zeros(size(Wind_polar_raw,1)/downsamplingsverdi,3);
t=zeros(size(Wind_polar_raw,1)/downsamplingsverdi,1);
for n=1:size(Wind_polar_raw,1)/downsamplingsverdi
    tmp=Wind_polar_raw(downsamplingsverdi*n-(downsamplingsverdi-1):downsamplingsverdi*n,:);
    Wind_polar(n,:)=mean(tmp(tmp(:,1)<500,:),1);
    t(n,1)=mean(t_raw(downsamplingsverdi*n-(downsamplingsverdi-1):downsamplingsverdi*n));
    if isnan(Wind_polar(n,:))
        Wind_polar(n,:)=Wind_polar(n-1,:);
        disp(['Missing values n= ' num2str(n) '  t=' num2str(round(t(n,1)))])
    end
end

%% Select data range
%disp('Select data range')
%[xo yo]=ginput(2);
xo=[1 length(Wind_polar)]';
yo=[-10 10]';
Wind_polar=Wind_polar(t>xo(1,1) & t<xo(2,1),:);
t=t(t>xo(1,1) & t<xo(2,1));
%% Plot selected data
t=t-t(1,1);
%figure
subplot(3,1,1)
plot(t,Wind_polar(:,1))
ylim([0 360])

subplot(3,1,2)
plot(t,Wind_polar(:,2))
ylim([0 40])

subplot(3,1,3)
plot(t,Wind_polar(:,3))
ylim([-10 10])
%% Transform to cartesian coordinate system
mean_dir=mean(Wind_polar(:,1));
phi=(Wind_polar(:,1)-mean_dir)*2*pi/360;
Wind_cartesian=zeros(size(phi,1),3);
Wind_cartesian(:,1)=Wind_polar(:,2).*cos(phi);
Wind_cartesian(:,2)=Wind_polar(:,2).*sin(phi);
Wind_cartesian(:,3)=Wind_polar(:,3);

% for i=1:3
% Wind_cartesian(:,i)=Wind_cartesian(:,i)-mean(Wind_cartesian(:,i));
% end


t=t-t(1,1);
figure
subplot(3,1,1)
plot(t,Wind_cartesian(:,1))
ylim([0 20])

subplot(3,1,2)
plot(t,Wind_cartesian(:,2))
ylim([-10 10])

subplot(3,1,3)
plot(t,Wind_cartesian(:,3))
ylim([-10 10])




% %% Plot time series and fitted normal distribution
V=mean(Wind_cartesian(:,1));
Iu=std(Wind_cartesian(:,1))/V;
Iv=std(Wind_cartesian(:,2))/V;
Iw=std(Wind_cartesian(:,3))/V;
figure
subplot(3,2,1)
plot(t,Wind_cartesian(:,1))
ylim([0 30])
title(['Mean Wind V=' num2str(1/10*round(V*10)) ' I_u=' num2str(1/100*round(Iu*100))])
subplot(3,2,3)
plot(t,Wind_cartesian(:,2))
ylim([-10 10])
title(['I_v=' num2str(1/100*round(Iv*100))])
subplot(3,2,5)
plot(t,Wind_cartesian(:,3))
ylim([-10 10])
title(['I_w=' num2str(1/100*round(Iw*100))])
subplot(3,2,2)
histfit(Wind_cartesian(:,1))
%title(['Fil: ' filnavn])
subplot(3,2,4)
histfit(Wind_cartesian(:,2))
subplot(3,2,6)
histfit(Wind_cartesian(:,3))
%% Estimate spectra using FFT
titler=['u -  fft';'v -  fft';'w -  fft';'u -  psd';'v -  psd';'w -  psd';'u - norm';'v - norm';'w - norm'];
%figure
Fs=1/(t(2)-t(1));
clear X
clear freq
clear Spectra
for n=1:3
    [X(n,:),freq(n,:)]=positiveFFT(Wind_cartesian(:,n).',Fs);
    Spectra(n,:)=X(n,:).*conj(X(n,:))/(2*2*pi*(freq(n,2)-freq(n,1)));
    %subplot(3,3,n)
    %loglog(2*pi*freq,Spectra(n,:))
    %title(titler(n,:), 'FontSize', 14)
    %hold on
    %grid on
    %loglog(2*pi*freq(1,:),0.01*(2*pi*freq(1,:)).^(-5/3),'k')
end
% Estimate spectra using welch
N=size(Wind_cartesian,1);                             % Number of elements in the vectors
Fs=1/(t(2)-t(1));                                     % Sampling frequency
nfft=1*N;  
Hs=spectrum.welch('Hamming',N/10,50);
%figure



%An=3*[6.5 0.53 1.11];


% Fungerer perfekt med cpsd:
% An=[20; 9.4; 5.4];
% Cn=0.01*[2 0.3 4];
%%
%close all
for j=11%:1:15
% Fungerer med psd:
 An=[2; 9.4; 0.4];
 Cn=[0.75 0.75 0.4];
eksponent=(7/6);%0.1*j;
%An(3)=0.6;
%Cn(3)=0.3;
%fungerer normalisert:
%An=[13; 4; 0.5];
%Cn=[3 2 0.25];

stdavvik=[1.6884; 1.3629; 0.5269];
clear Spectra_welch
for n=1%:2:3%size(Wind_cartesian,2)
    h=psd(Hs,Wind_cartesian(:,n)-mean(Wind_cartesian(:,n)),'NFFT',nfft,'Fs',Fs);
    fakse=2*pi*h.Frequencies;
    Spectra_welch(:,n)=1/(2*pi)*h.Data;
    %subplot(3,3,n+3)
    %figure
    %loglog(2*pi*h.Frequencies,Spectra_welch(:,n))
    %hold on
    %grid on
    %title(titler(n+3,:), 'FontSize', 14)
    %title(['integral: ' num2str(trapz(2*pi*h.Frequencies,Spectra_welch(:,n))) ' varians: ' num2str(var(Wind_cartesian(:,n)))])
    %loglog(2*pi*freq(1,:),0.09*(2*pi*freq(1,:)).^(-5/4),'k')
    %loglog(2*pi*freq(1,:),0.02*(2*pi*freq(1,:)).^(-5/3),'k')
    
    A=An(n);
    C=Cn(n);
    standardavvik=stdavvik(n);
    %strommenAutospekter
    %xlim([0.01 100])
end

end
%%
clear Spectra_welch
clear Spectra_norm
for n=1:size(Wind_cartesian,2)
    h=psd(Hs,Wind_cartesian(:,n)-mean(Wind_cartesian(:,n)),'NFFT',nfft,'Fs',Fs);
    fakse=2*pi*h.Frequencies;
    Spectra_welch(:,n)=1/(2*pi)*h.Data;
    %subplot(3,3,n+6)
    %loglog(2*pi*h.Frequencies,Spectra_welch(:,n))
    Spectra_norm(:,n)=Spectra_welch(:,n).*fakse;
    %semilogx(2*pi*h.Frequencies,Spectra_norm(:,n))
    %hold on
    %grid on
    %title(titler(n+6,:), 'FontSize', 14)
    %loglog(2*pi*freq(1,:),0.03*(2*pi*freq(1,:)).^(-5/3),'k')
    A=An(n);
    C=Cn(n);    
    standardavvik=stdavvik(n);
    %strommenAutospekter
    %xlim([0.01 100])
end

%set(gcf, 'Position', [400, 100, 1449, 895])
% for s=1:5:50
% 
% An=(s/250)*[6.8; 9.4; 9.4];
% 
%figure

% %%%%%%%   testest
% for n=1:3
% 
% 
%     loglog(2*pi*h.Frequencies,Spectra_welch(:,n))
%     hold on
%     grid on
%     title(titler(n+3,:), 'FontSize', 14)
%     %loglog(2*pi*freq(1,:),0.09*(2*pi*freq(1,:)).^(-5/4),'k')
%     %loglog(2*pi*freq(1,:),0.02*(2*pi*freq(1,:)).^(-5/3),'k')
%     
%     A=An(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.01 10])
%     ylim([10^-3 10^5])
% % 
% %     saveas(gcf,['vindspekter_A_' num2str(An(n)) '.png'],'png')
% % 
% % 
% % 
%  end

%close
titler2=['S_u_u';'S_u_w';'S_w_w'];

%figure
%An=[0.3; 0.3; 0.05];

%Cn=[1.5 1.5 1.5];
clear vind
for n=1:3
vind(:,n)=Wind_cartesian(:,n)-mean(Wind_cartesian(:,n));
end

% for n=1:3
%     [h fre]=cpsd(vind(:,n),vind(:,n));
%     fakse=fre*2*pi;
%     a=subplot(3,1,n);
%     loglog(fre,h/(2*pi))
%     hold on
%     grid on
%     title(titler2(n,:), 'FontSize', 14)
%     A=An(n);
%     C=Cn(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.001 10])
% end



%An=[20 20 9.4];
%Cn=[0.02 0.003 0.05];

%An=[6.5 0.53 1.11];    % Ole sine verdier




% 
% n=1;
%     [h fre]=cpsd(vind(:,n),vind(:,n));
%     fakse=fre*2*pi;
%     a=subplot(3,1,n);
%     loglog(fre,h/(2*pi))
%     hold on
%     grid on
%     title(titler2(n,:), 'FontSize', 14)
%     A=An(n);
%     C=Cn(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.01 10])
% n=2;
%     [h fre]=cpsd(vind(:,n+1),vind(:,n-1));
%     fakse=fre*2*pi;
%     a=subplot(3,1,n);
%     loglog(fre,h/(2*pi))
%     hold on
%     grid on
%     title(titler2(n,:), 'FontSize', 14)
%     A=An(n);
%     C=Cn(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.01 10])
% n=3;
%     [h fre]=cpsd(vind(:,n),vind(:,n));
%     fakse=fre*2*pi;
%     a=subplot(3,1,n);
%     loglog(fre,h/(2*pi))
%     hold on
%     grid on
%     title(titler2(n,:), 'FontSize', 14)
%     A=An(n);
%     C=Cn(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.01 10])
% 
% set(gcf, 'Position', [400, 100, 1449, 895])
% 


%figure

% for n=1:size(Wind_cartesian,2)
%     h=psd(Hs,Wind_cartesian(:,n)-mean(Wind_cartesian(:,n)),'NFFT',nfft,'Fs',Fs);
%     fakse=2*pi*h.Frequencies;
%     Spectra_welch(:,n)=1/(2*pi)*h.Data;
%     subplot(1,3,n)
%     %loglog(2*pi*h.Frequencies,Spectra_welch(:,n))
%     Spectra_norm(:,n)=Spectra_welch(:,n).*fakse;
%     semilogx(2*pi*h.Frequencies,Spectra_norm(:,n))
%     hold on
%     grid on
%     title(titler(n,:), 'FontSize', 14)
%     %loglog(2*pi*freq(1,:),0.03*(2*pi*freq(1,:)).^(-5/3),'k')
%     A=An(n);
%     standardavvik=stdavvik(n);
%     strommenAutospekter
%     xlim([0.001 100])
% end
% 



%saveas(a,'vindspekter.png','png')

%saveas(gcf,[num2str(teller) '.png'],'png')

%close
%close

%close all